#!/bin/sh

set -e
. ./.common.sh

rm -Rf $DAHDI $DAHDI_ORIG
tar xzf $DAHDI_ORIG.tar.gz
mv $DAHDI_ORIG $DAHDI

patch -d $DAHDIDIR/linux/include/dahdi/ < $BASEDIR/parabel/kernel.h.patch
cd $DAHDIDIR/linux/drivers/dahdi/
patch < $BASEDIR/parabel/dahdi-base.c.patch
patch < $BASEDIR/parabel/dahdi_dynamic.c.patch
patch < $BASEDIR/parabel/dahdi_dynamic_eth.c.patch
patch < $BASEDIR/parabel/dahdi_dummy.c.patch

# Comment if you don't need OSLEC echo canceller
mkdir -p $DAHDIDIR/linux/drivers/staging/echo
cp -Rp $BASEDIR/oslec/. $DAHDIDIR/linux/drivers/staging/echo
sed -i "s|#ifdef CONFIG_DAHDI_MMX|#if defined (CONFIG_DAHDI_MMX) \&\& \!defined (CONFIG_X86_64)|" $DAHDIDIR/linux/drivers/dahdi/arith.h

# Uncomment to enable MMX optimization
#sed -i "s|/\* #define CONFIG_DAHDI_MMX \*/|#define CONFIG_DAHDI_MMX|" $DAHDIDIR/linux/include/dahdi/dahdi_config.h
#echo 'CFLAGS_echo.o += -DUSE_MMX' >> Kbuild
# Uncomment to enable SSE2 optimization
#sed -i "s|/\* #define CONFIG_DAHDI_MMX \*/|#define CONFIG_DAHDI_MMX|" $DAHDIDIR/linux/include/dahdi/dahdi_config.h
#echo 'CFLAGS_echo.o += -DUSE_SSE2' >> Kbuild

cd $BASEDIR
# Disable loading Digium's firmware from website (we don't need it)
sed -i "s|prereq: include/dahdi/version.h firmware-loaders|prereq: include/dahdi/version.h|" $DAHDI/linux/Makefile
sed -i "s|install-firmware install-xpp-firm|install-include|" $DAHDI/linux/Makefile
# Uncomment to enable HDLC support
#sed -i "s|/\* #define CONFIG_DAHDI_NET \*/|#define CONFIG_DAHDI_NET|" $DAHDI/linux/include/dahdi/dahdi_config.h
# Uncomment to disable tasklet in dahdi_dynamic
#sed -i "s|#define ENABLE_TASKLETS|//#define ENABLE_TASKLETS|" $DAHDI/linux/drivers/dahdi/dahdi_dynamic.c
# Uncomment to enable short flash time - 60ms. Default: 200ms.
#sed -i "s|/\* #define SHORT_FLASH_TIME \*/|#define SHORT_FLASH_TIME|" $DAHDI/linux/include/dahdi/dahdi_config.h
# Uncommend to build dahdi_dummy
sed -i "s|#obj-\$(DAHDI_BUILD_ALL)\$(CONFIG_DAHDI_DUMMY)|obj-\$(DAHDI_BUILD_ALL)\$(CONFIG_DAHDI_DUMMY)|" $DAHDI/linux/drivers/dahdi/Kbuild
# Put any additional patches/commands here.
#editor $DAHDI/linux/include/dahdi/dahdi_config.h

cd $DAHDIDIR
# Uncomment to enable additional DAHDI features (example for tools)
#(cd tools && ./configure --with-dahdi=../linux && make menuselect)
make $MAKEOPS

cd $BASEDIR
rm -rf quasar quasarm quasar-$QUASAR_VER  quasarm-$QUASARM_VER
tar xfj quasar-$QUASAR_VER.tar.bz2
mv quasar-$QUASAR_VER quasar
make -C quasar $MAKEOPS $QUASAROPS

make -C dahdi_tdmox $MAKEOPS $QUASAROPS
